diff --git a/changelog b/changelog
index 0aeec85..19aff4b 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,4 @@
+20070812 tpd re-merge input branch
 20070811 tpd src/input/Makefile add classtalk, calcprob
 20070811 tpd src/input/limit.input.pamphlet updated with new tests
 20070811 tpd src/input/intbypart.input.pamphlet updated with new tests
diff --git a/src/input/Makefile.pamphlet b/src/input/Makefile.pamphlet
index 621d8ed..34850f2 100644
--- a/src/input/Makefile.pamphlet
+++ b/src/input/Makefile.pamphlet
@@ -292,9 +292,10 @@ REGRES= algaggr.regress algbrbf.regress  algfacob.regress alist.regress  \
     binary.regress    bop.regress      bstree.regress   bouquet.regress \
     bug10069.regress \
     bugs.regress      bug10312.regress bug6357.regress  bug9057.regress \
+    calcprob.regress  \
     calculus2.regress calculus.regress cardinal.regress card.regress \
     carten.regress    cclass.regress   char.regress     ch.regress \
-    chtheorem.regress \
+    chtheorem.regress classtalk.regress \
     clifford.regress  clif.regress     coercels.regress collect.regress \
     complex.regress   conformal.regress \
     constant.regress  contfrac.regress contfrc.regress \
@@ -486,10 +487,10 @@ FILES= ${OUT}/algaggr.input  ${OUT}/algbrbf.input    ${OUT}/algfacob.input \
        ${OUT}/bernpoly.input ${OUT}/binary.input     ${OUT}/bop.input \
        ${OUT}/bouquet.input  ${OUT}/bstree.input     ${OUT}/bug6357.input \
        ${OUT}/bug9057.input  ${OUT}/bug10069.input   ${OUT}/bug10312.input \
-       ${OUT}/calculus.input \
+       ${OUT}/calcprob.input ${OUT}/calculus.input \
        ${OUT}/cardinal.input ${OUT}/card.input       ${OUT}/carten.input \
        ${OUT}/cclass.input   ${OUT}/cdraw.input      ${OUT}/char.input \
-       ${OUT}/ch.input       ${OUT}/chtheorem.input \
+       ${OUT}/ch.input       ${OUT}/chtheorem.input  ${OUT}/classtalk.input \
        ${OUT}/clifford.input ${OUT}/clif.input \
        ${OUT}/coercels.input ${OUT}/collect.input    ${OUT}/color.input \
        ${OUT}/complex.input  ${OUT}/cone.input       ${OUT}/conformal.input \
@@ -669,12 +670,13 @@ DOCFILES= \
   ${DOC}/c06fqf.input.dvi      ${DOC}/c06frf.input.dvi     \
   ${DOC}/c06fuf.input.dvi      ${DOC}/c06gbf.input.dvi     \
   ${DOC}/c06gcf.input.dvi      ${DOC}/c06gqf.input.dvi     \
-  ${DOC}/c06gsf.input.dvi      ${DOC}/calculus2.input.dvi  \
+  ${DOC}/c06gsf.input.dvi      ${DOC}/calcprob.input.dvi   \
+  ${DOC}/calculus2.input.dvi  \
   ${DOC}/calculus.input.dvi    ${DOC}/cardinal.input.dvi   \
   ${DOC}/card.input.dvi        ${DOC}/carten.input.dvi     \
   ${DOC}/cclass.input.dvi      ${DOC}/cdraw.input.dvi      \
   ${DOC}/char.input.dvi        ${DOC}/ch.input.dvi         \
-  ${DOC}/chtheorem.input.dvi \
+  ${DOC}/chtheorem.input.dvi   ${DOC}/classtalk.input.dvi  \
   ${DOC}/clifford.input.dvi    ${DOC}/clif.input.dvi       \
   ${DOC}/coercels.input.dvi    ${DOC}/collect.input.dvi    \
   ${DOC}/color.input.dvi       ${DOC}/complex.input.dvi    \
diff --git a/src/input/calcprob.input.pamphlet b/src/input/calcprob.input.pamphlet
new file mode 100644
index 0000000..f41808d
--- /dev/null
+++ b/src/input/calcprob.input.pamphlet
@@ -0,0 +1,124 @@
+\documentclass{article}
+\usepackage{axiom}
+\begin{document}
+\title{\$SPAD/src/input calcprob.input}
+\author{Timothy Daly}
+\maketitle
+\begin{abstract}
+Cover a range of calculus problems
+\end{abstract}
+\eject
+\tableofcontents
+\eject
+<<*>>=
+)spool calcprob.output
+)set message test on
+)set message auto off
+)clear all
+ 
+--S 1 
+solve(3*x-(x-7)=4*x-5,x)
+--R
+--R   (1)  [x= 6]
+--R                              Type: List Equation Fraction Polynomial Integer
+--E 1
+
+--S 2
+solve(4*x-3*y=9,y)::List Equation Polynomial Fraction Integer
+--R
+--R            4
+--R   (2)  [y= - x - 3]
+--R            3
+--R                              Type: List Equation Polynomial Fraction Integer
+--E 2
+
+--S 3
+solve(A*x+B*y=C,y)
+--R
+--R            - A x + C
+--R   (3)  [y= ---------]
+--R                B
+--R                              Type: List Equation Fraction Polynomial Integer
+--E 3
+
+--S 4
+m:=3*x-4*(x-(2/3)*y)=(4/5)*x-(7*y+3)
+--R
+--R        8               4
+--R   (4)  - y - x= - 7y + - x - 3
+--R        3               5
+--R                                   Type: Equation Polynomial Fraction Integer
+--E 4
+
+--S 5
+n:=solve(m*15,y)
+--R
+--R            27x - 45
+--R   (5)  [y= --------]
+--R               145
+--R                              Type: List Equation Fraction Polynomial Integer
+--E 5
+
+--S 6
+p:=n.1*145-27*x
+--R
+--R   (6)  145y - 27x= - 45
+--R                                   Type: Equation Fraction Polynomial Integer
+--E 6
+
+--S 7
+(x1,y1):=(-3,-8)
+--R
+--R   (7)  - 8
+--R                                                                Type: Integer
+--E 7
+
+--S 8
+(x2,y2):=(-6,2)
+--R
+--R   (8)  2
+--R                                                        Type: PositiveInteger
+--E 8
+
+--S 9
+m:=(y2-y1)/(x2-x1)
+--R
+--R          10
+--R   (9)  - --
+--R           3
+--R                                                       Type: Fraction Integer
+--E 9
+
+--S 10
+solve(y1=m*x1+b,b)
+--R
+--R   (10)  [b= - 18]
+--R                              Type: List Equation Fraction Polynomial Integer
+--E 10
+
+--S 11
+b:=-18
+--R
+--R   (11)  - 18
+--R                                                                Type: Integer
+--E 11
+
+--S 12
+y=m*x+b
+--R
+--R              10
+--R   (12)  y= - -- x - 18
+--R               3
+--R                                   Type: Equation Polynomial Fraction Integer
+--E 12
+)spool 
+)lisp (bye)
+ 
+@
+\eject
+\begin{thebibliography}{99}
+\bibitem{1} nothing
+\end{thebibliography}
+\end{document}
+
+ 
diff --git a/src/input/classtalk.input.pamphlet b/src/input/classtalk.input.pamphlet
new file mode 100644
index 0000000..7f89df1
--- /dev/null
+++ b/src/input/classtalk.input.pamphlet
@@ -0,0 +1,733 @@
+\documentclass{article}
+\usepackage{axiom}
+\begin{document}
+\title{\$SPAD/src/input classtalk.input}
+\author{Timothy Daly}
+\maketitle
+\begin{abstract}
+These are examples from the talk ``Axiom in an Educational Setting''.
+\end{abstract}
+\eject
+\tableofcontents
+\eject
+<<*>>=
+)spool classtalk.output
+)set message test on
+)set message auto off
+)set break resume
+)clear all
+
+@
+\section{Numbers}
+<<*>>=
+--S 1
+1
+--R
+--R   (1)  1
+--R                                                        Type: PositiveInteger
+--E 1
+
+--S 2
+1/2
+--R
+--R        1
+--R   (2)  -
+--R        2
+--R                                                       Type: Fraction Integer
+--E 2
+
+--S 3
+3+4*%i
+--R
+--R   (3)  3 + 4%i
+--R                                                        Type: Complex Integer
+--E 3
+
+--S 4
+3.4
+--R
+--R   (4)  3.4
+--R                                                                  Type: Float
+--E 4
+
+--S 5
+X::ROMAN
+--R
+--R   (5)  X
+--R                                                           Type: RomanNumeral
+--E 5
+
+--S 6
+binary(5)
+--R
+--R   (6)  101
+--R                                                        Type: BinaryExpansion
+--E 6
+
+--S 7
+factor(60)
+--R
+--R         2
+--R   (7)  2 3 5
+--R                                                       Type: Factored Integer
+--E 7
+
+--S 8
+q:=(y-1)*x*(z+5)
+--R
+--R   (8)  (x y - x)z + 5x y - 5x
+--R                                                     Type: Polynomial Integer
+--E 8
+
+--S 9
+factor q
+--R
+--R   (9)  x(y - 1)(z + 5)
+--R                                            Type: Factored Polynomial Integer
+--E 9
+
+--S 10
+eval(q,[x=5,y=6,z=7])
+--R
+--R   (10)  300
+--R                                                     Type: Polynomial Integer
+--E 10
+
+--S 11
+eval(q,[x=5,y=6])
+--R
+--R   (11)  25z + 125
+--R                                                     Type: Polynomial Integer
+--E 11
+
+@
+\section{Trigonometry}
+<<*>>=
+--S 12
+b:=[log a, exp a, asin a, acos a, atan a, acot a, sinh a]
+--R
+--R                   a
+--R   (12)  [log(a),%e ,asin(a),acos(a),atan(a),acot(a),sinh(a)]
+--R                                                Type: List Expression Integer
+--E 12
+
+--S 13
+[exp b.1, log b.2, sin b.3, cos b.4, tan b.5, cot b.6, asinh b.7]
+--R
+--R   (13)  [a,a,a,a,a,a,a]
+--R                                                Type: List Expression Integer
+--E 13
+
+--S 14
+a:=.7
+--R
+--R   (14)  0.7
+--R                                                                  Type: Float
+--E 14
+
+--S 15
+b:=[log a, exp a, asin a, acos a, atan a, acot a, sinh a]
+--R
+--R   (15)
+--R   [- 0.3566749439 3873237891, 2.0137527074 704765216, 0.7753974966 1075306374,
+--R    0.7953988301 8414355549, 0.6107259643 8920861654, 0.9600703624 0568800269,
+--R    0.7585837018 3953350346]
+--R                                                             Type: List Float
+--E 15
+
+--S 16
+[exp b.1, log b.2, sin b.3, cos b.4, tan b.5, cot b.6, asinh b.7]
+--R
+--R   (16)  [0.7,0.7,0.7,0.7,0.7,0.7,0.7]
+--R                                                             Type: List Float
+--E 16
+
+--S 17
+simplify(sin(x)**2+cos(x)**2)
+--R
+--R   (17)  1
+--R                                                     Type: Expression Integer
+--E 17
+
+@
+\section{Polynomial Manipulations}
+<<*>>=
+)clear all
+--S 18
+eq1:=A*x^2 + B*x*y + C*y^2 + D*x + E*y + F
+--R
+--R           2                   2
+--R   (1)  C y  + (B x + E)y + A x  + D x + F
+--R                                                     Type: Polynomial Integer
+--E 18
+
+--S 19
+rotatex:=x'*cos(t)-y'*sin(t)
+--R
+--R   (2)  - y' sin(t) + x' cos(t)
+--R                                                     Type: Expression Integer
+--E 19
+
+--S 20
+rotatey:=x'*sin(t)+y'*cos(t)
+--R
+--R   (3)  x' sin(t) + y' cos(t)
+--R                                                     Type: Expression Integer
+--E 20
+
+--S 21
+eval(eq1,[x=rotatex, y=rotatey])
+--R
+--R   (4)
+--R          2                 2       2
+--R     (A y'  - B x' y' + C x' )sin(t)
+--R   + 
+--R             2                        2
+--R     ((- B y'  + (2C - 2A)x' y' + B x' )cos(t) - D y' + E x')sin(t)
+--R   + 
+--R          2                 2       2
+--R     (C y'  + B x' y' + A x' )cos(t)  + (E y' + D x')cos(t) + F
+--R                                                     Type: Expression Integer
+--E 21
+
+@
+\section{Polynomials over Simple Algebraic Extension Fields}
+<<*>>=
+)clear all
+--S 22
+a:=rootOf(a^2+a+1)
+--R
+--R   (1)  a
+--R                                                        Type: AlgebraicNumber
+--E 22
+
+--S 23
+factor(x^2+3)
+--R
+--R         2
+--R   (2)  x  + 3
+--R                                            Type: Factored Polynomial Integer
+--E 23
+
+--S 24
+factor(x^2+3,[a])
+--R
+--R   (3)  (x - 2a - 1)(x + 2a + 1)
+--R                                    Type: Factored Polynomial AlgebraicNumber
+--E 24
+
+--S 25
+definingPolynomial(a)
+--R
+--R         2
+--R   (4)  a  + a + 1
+--R                                                        Type: AlgebraicNumber
+--E 25
+
+--S 26
+zerosOf(b^2+b+1,b)
+--R
+--R          +---+        +---+
+--R         \|- 3  - 1 - \|- 3  - 1
+--R   (5)  [----------,------------]
+--R              2           2
+--R                                                Type: List Expression Integer
+--E 26
+
+@
+\section{Derivatives}
+<<*>>=
+--S 27
+differentiate(sin(x),x)
+--R
+--R   (6)  cos(x)
+--R                                                     Type: Expression Integer
+--E 27
+
+--S 28
+differentiate(sin(x),x,2)
+--R
+--R   (7)  - sin(x)
+--R                                                     Type: Expression Integer
+--E 28
+
+--S 29
+differentiate(cos(z)/(x^2+y^3),[x,y,z],[1,2,3])
+--R
+--R                    4      3
+--R            (- 84x y  + 24x y)sin(z)
+--R   (8)  --------------------------------
+--R         12     2 9     4 6     6 3    8
+--R        y   + 4x y  + 6x y  + 4x y  + x
+--R                                                     Type: Expression Integer
+--E 29
+
+--S 30
+y:=operator y
+--R
+--R   (9)  y
+--R                                                          Type: BasicOperator
+--E 30
+
+--S 31
+deqx:=D(y(x),x,2)+D(y(x),x)+y(x)
+--R 
+--R
+--R          ,,       ,
+--R   (10)  y  (x) + y (x) + y(x)
+--R
+--R                                                     Type: Expression Integer
+--E 31
+
+--S 32
+solve(deqx,y,x)
+--R
+--R                                              x     x
+--R                                      +-+   - -   - -      +-+
+--R                                    x\|3      2     2    x\|3
+--R   (11)  [particular= 0,basis= [cos(-----)%e   ,%e   sin(-----)]]
+--R                                      2                    2
+--RType: Union(Record(particular: Expression Integer,basis: List Expression Integer),...)
+--E 32
+
+@
+\section{Limits}
+<<*>>=
+)clear all
+--S 33
+limit((x^2-3*x+2)/(x^2-1),x=1)
+--R
+--R          1
+--R   (1)  - -
+--R          2
+--R               Type: Union(OrderedCompletion Fraction Polynomial Integer,...)
+--E 33
+
+--S 34
+limit(x*log(x),x=0)
+--R
+--R   (2)  [leftHandLimit= "failed",rightHandLimit= 0]
+--RType: Union(Record(leftHandLimit: Union(OrderedCompletion Expression Integer,"failed"),rightHandLimit: Union(OrderedCompletion Expression Integer,"failed")),...)
+--E 34
+
+--S 35
+limit(sinh(a*x)/tan(b*x),x=0)
+--R
+--R        a
+--R   (3)  -
+--R        b
+--R                        Type: Union(OrderedCompletion Expression Integer,...)
+--E 35
+
+--S 36
+limit(sqrt(3*x^2+1)/(5*x),x=%plusInfinity)
+--R
+--R         +-+
+--R        \|3
+--R   (4)  ----
+--R          5
+--R                        Type: Union(OrderedCompletion Expression Integer,...)
+--E 36
+
+--S 37
+complexLimit((2+z)/(1-z),z=%infinity)
+--R
+--R   (5)  - 1
+--R                         Type: OnePointCompletion Fraction Polynomial Integer
+--E 37
+
+@
+\section{Indefinite Integration}
+<<*>>=
+)clear all
+--S 38
+integrate(1+sqrt(x)/x,x)
+--R
+--R          +-+
+--R   (1)  2\|x  + x
+--R                                          Type: Union(Expression Integer,...)
+--E 38
+
+--S 39
+integrate(sin(x)/x,x)
+--R
+--R   (2)  Si(x)
+--R                                          Type: Union(Expression Integer,...)
+--E 39
+
+@
+This used to give the answer:
+$$\frac{\sqrt{x}\sqrt{\pi} erf(x\sqrt{a})}{2a}$$
+<<*>>=
+--S 40
+integrate(exp(-a*x^2),x)
+--R
+--R           x       2
+--R         ++    - %Q a
+--R   (3)   |   %e      d%Q
+--R        ++
+--R                                          Type: Union(Expression Integer,...)
+--E 40
+
+--S 41
+integrate(sin(x)/x^2,x)
+--R
+--R           x
+--R         ++  sin(%Q)
+--R   (4)   |   ------- d%Q
+--R        ++       2
+--R               %Q
+--R                                          Type: Union(Expression Integer,...)
+--E 41
+
+@
+\section{Definite Integration}
+<<*>>=
+)clear all
+--S 42
+integrate(exp(-x)/sqrt(x),x=0..%plusInfinity)
+--R
+--R         _ 1
+--R   (1)  | (-)
+--R           2
+--R                    Type: Union(f1: OrderedCompletion Expression Integer,...)
+--E 42
+
+--S 43
+integrate(1/x^2,x=-1..1)
+--R 
+--R 
+--RDaly Bug
+--R   >> Error detected within library code:
+--R   integrate: pole in path of integration
+--R
+--R   Continuing to read the file...
+--R
+--E 43
+
+)clear all
+
+@
+This used to return
+$$\frac{4\log{(4)}-8\log{(2)}+3\pi}{12}$$
+<<*>>=
+--S 44
+integrate(sin(x)^3/(sin(x)^3+cos(x)^3),x=0..%pi/2,"noPole")
+--R
+--R        2log(16) - 4log(4) + 3%pi
+--R   (1)  -------------------------
+--R                    12
+--R                    Type: Union(f1: OrderedCompletion Expression Integer,...)
+--E 44
+
+--S 45
+integrate(exp(-x^2)*log(x)^2,x=0..%plusInfinity)
+--R
+--R         _ 1             1     _ 1         1 2
+--R        | (-)polygamma(1,-) + | (-)digamma(-)
+--R           2             2       2         2
+--R   (2)  --------------------------------------
+--R                           8
+--R                    Type: Union(f1: OrderedCompletion Expression Integer,...)
+--E 45
+
+@
+\section{Laplace Transformations}
+<<*>>=
+)clear all
+
+--S 46
+laplace(sin(a*t)*cosh(a*t)-cos(a*t)*sinh(a*t),t,s)
+--R
+--R             3
+--R           4a
+--R   (1)  --------
+--R         4     4
+--R        s  + 4a
+--R                                                     Type: Expression Integer
+--E 46
+
+--S 47
+laplace(2/t * (1-cos(a*t)),t,s)
+--R
+--R             2    2
+--R   (2)  log(s  + a ) - 2log(s)
+--R                                                     Type: Expression Integer
+--E 47
+
+--S 48
+laplace((exp(a*t)-exp(b*t))/t,t,s)
+--R
+--R   (3)  - log(s - a) + log(s - b)
+--R                                                     Type: Expression Integer
+--E 48
+
+--S 49
+laplace(exp(a*t+b)*Ei(c*t),t,s)
+--R
+--R          b    s + c - a
+--R        %e log(---------)
+--R                   c
+--R   (4)  -----------------
+--R              s - a
+--R                                                     Type: Expression Integer
+--E 49
+
+@
+\section{Clifford Algebras}
+{\tt CliffordAlgebra(n,K,Q)} defines a vector space of dimension $2^n$
+over $K$, given a quadratic form $Q$ on $K^n$ (e.q. quaternions).
+<<*>>=
+)clear all
+--S 50
+K:=Fraction Polynomial Integer
+--R
+--R   (1)  Fraction Polynomial Integer
+--R                                                                 Type: Domain
+--E 50
+
+--S 51
+qf:QFORM(2,K):=quadraticForm matrix([[-1,0],[0,-1]])$(SQMATRIX(2,K))
+--R
+--R        +- 1   0 +
+--R   (2)  |        |
+--R        + 0   - 1+
+--R                           Type: QuadraticForm(2,Fraction Polynomial Integer)
+--E 51
+
+--S 52
+i:=e(1)$CLIF(2,K,qf)
+--R
+--R   (3)  e
+--R         1
+--R                  Type: CliffordAlgebra(2,Fraction Polynomial Integer,MATRIX)
+--E 52
+
+--S 53
+j:=e(2)$CLIF(2,K,qf)
+--R
+--R   (4)  e
+--R         2
+--R                  Type: CliffordAlgebra(2,Fraction Polynomial Integer,MATRIX)
+--E 53
+
+--S 54
+k:=i*j
+--R
+--R   (5)  e e
+--R         1 2
+--R                  Type: CliffordAlgebra(2,Fraction Polynomial Integer,MATRIX)
+--E 54
+
+--S 55
+x:=a+b*i+c*j+d*k
+--R
+--R   (6)  a + b e  + c e  + d e e
+--R               1      2      1 2
+--R                  Type: CliffordAlgebra(2,Fraction Polynomial Integer,MATRIX)
+--E 55
+
+--S 56
+y:=m+f*i+g*j+h*k
+--R
+--R   (7)  m + f e  + g e  + h e e
+--R               1      2      1 2
+--R                  Type: CliffordAlgebra(2,Fraction Polynomial Integer,MATRIX)
+--E 56
+
+--S 57
+x+y
+--R
+--R   (8)  m + a + (f + b)e  + (g + c)e  + (h + d)e e
+--R                        1           2           1 2
+--R                  Type: CliffordAlgebra(2,Fraction Polynomial Integer,MATRIX)
+--E 57
+
+--S 58
+x*y
+--R
+--R   (9)
+--R     a m - d h - c g - b f + (b m + c h - d g + a f)e
+--R                                                     1
+--R   + 
+--R     (c m - b h + a g + d f)e  + (d m + a h + b g - c f)e e
+--R                             2                           1 2
+--R                  Type: CliffordAlgebra(2,Fraction Polynomial Integer,MATRIX)
+--E 58
+
+@
+\section{Taylor Series}
+<<*>>=
+)clear all
+--S 59
+taylor(sin(x),x=0)
+--R
+--R            1  3    1   5     1   7      1    9      11
+--R   (1)  x - - x  + --- x  - ---- x  + ------ x  + O(x  )
+--R            6      120      5040      362880
+--R                         Type: UnivariateTaylorSeries(Expression Integer,x,0)
+--E 59
+
+@
+\section{Laurent Series}
+<<*>>=
+--S 60
+laurent(x/log(x),x=1)
+--R
+--R   (2)
+--R            - 1   3    5            1        2    11        3    11         4
+--R     (x - 1)    + - + -- (x - 1) - -- (x - 1)  + --- (x - 1)  - ---- (x - 1)
+--R                  2   12           24            720            1440
+--R   + 
+--R      271         5    13         6     7297         7     425         8
+--R     ----- (x - 1)  - ---- (x - 1)  + ------- (x - 1)  - ------ (x - 1)
+--R     60480            4480            3628800            290304
+--R   + 
+--R       530113         9            10
+--R     --------- (x - 1)  + O((x - 1)  )
+--R     479001600
+--R                        Type: UnivariateLaurentSeries(Expression Integer,x,1)
+--E 60
+
+@
+\section{Puiseux Series}
+<<*>>=
+--S 61
+puiseux(sqrt(sec(x)),x=3*%pi/2)
+--R 
+--R
+--R                    1                3                 7
+--R                  - -                -                 -
+--R             3%pi   2    1      3%pi 2    1       3%pi 2          3%pi 5
+--R   (3)  (x - ----)    + -- (x - ----)  + --- (x - ----)  + O((x - ----) )
+--R               2        12        2      160        2               2
+--R                 Type: UnivariatePuiseuxSeries(Expression Integer,x,(3*pi)/2)
+--E 61
+
+@
+\section{General Series}
+<<*>>=
+--S 62
+series(x^x,x=0)
+--R
+--R   (4)
+--R                         2            3            4            5
+--R                   log(x)   2   log(x)   3   log(x)   4   log(x)   5
+--R     1 + log(x)x + ------- x  + ------- x  + ------- x  + ------- x
+--R                      2            6            24          120
+--R   + 
+--R           6            7            8            9            10
+--R     log(x)   6   log(x)   7   log(x)   8   log(x)   9   log(x)    10      11
+--R     ------- x  + ------- x  + ------- x  + ------- x  + -------- x   + O(x  )
+--R       720          5040        40320        362880       3628800
+--R                   Type: GeneralUnivariatePowerSeries(Expression Integer,x,0)
+--E 62
+
+@
+\section{Matrices}
+<<*>>=
+)clear all
+--S 63
+m:=matrix [[1,2],[3,4]]
+--R
+--R        +1  2+
+--R   (1)  |    |
+--R        +3  4+
+--R                                                         Type: Matrix Integer
+--E 63
+
+--S 64
+4*m*(-5)
+--R
+--R        +- 20  - 40+
+--R   (2)  |          |
+--R        +- 60  - 80+
+--R                                                         Type: Matrix Integer
+--E 64
+
+--S 65
+n:=matrix [[1,0,-2],[-3,5,1]]
+--R
+--R        + 1   0  - 2+
+--R   (3)  |           |
+--R        +- 3  5   1 +
+--R                                                         Type: Matrix Integer
+--E 65
+
+--S 66
+m*n
+--R
+--R        +- 5  10   0 +
+--R   (4)  |            |
+--R        +- 9  20  - 2+
+--R                                                         Type: Matrix Integer
+--E 66
+
+--S 67
+hilb:=matrix([[1/(i+j) for i in 1..3] for j in 1..3])
+--R
+--R        +1  1  1+
+--R        |-  -  -|
+--R        |2  3  4|
+--R        |       |
+--R        |1  1  1|
+--R   (5)  |-  -  -|
+--R        |3  4  5|
+--R        |       |
+--R        |1  1  1|
+--R        |-  -  -|
+--R        +4  5  6+
+--R                                                Type: Matrix Fraction Integer
+--E 67
+
+--S 68
+inverse(hilb)
+--R
+--R        + 72    - 240   180 +
+--R        |                   |
+--R   (6)  |- 240   900   - 720|
+--R        |                   |
+--R        + 180   - 720   600 +
+--R                                     Type: Union(Matrix Fraction Integer,...)
+--E 68
+
+@
+\section{Systems of Equations}
+<<*>>=
+)clear all
+--S 69
+solve([x+y+z=8,3*x-2*y+z=0,x+2*y+2*z=17],[x,y,z])
+--R
+--R   (1)  [[x= - 1,y= 2,z= 7]]
+--R                         Type: List List Equation Fraction Polynomial Integer
+--E 69
+
+--S 70
+solve([x+2*y+3*z=2,2*x+3*y+4*z=2,3*x+4*y+5*z=2],[x,y,z])
+--R
+--R   (2)  [[x= %W - 2,y= - 2%W + 2,z= %W]]
+--R                         Type: List List Equation Fraction Polynomial Integer
+--E 70
+
+--S 71
+solve([[1,1,1],[3,-2,1],[1,2,2]],[8,0,17])
+--R
+--R   (3)  [particular= [- 1,2,7],basis= [[0,0,0]]]
+--RType: Record(particular: Union(Vector Fraction Integer,"failed"),basis: List Vector Fraction Integer)
+--E 71
+
+--S 72
+solve([[1,2,3],[2,3,4],[3,4,5]],[2,2,2])
+--R
+--R   (4)  [particular= [- 2,2,0],basis= [[1,- 2,1]]]
+--RType: Record(particular: Union(Vector Fraction Integer,"failed"),basis: List Vector Fraction Integer)
+--E 72
+)spool 
+)lisp (bye)
+ 
+@
+\eject
+\begin{thebibliography}{99}
+\bibitem{1} nothing
+\end{thebibliography}
+\end{document}
diff --git a/src/input/intbypart.input.pamphlet b/src/input/intbypart.input.pamphlet
index 72a04e5..0b26c61 100644
--- a/src/input/intbypart.input.pamphlet
+++ b/src/input/intbypart.input.pamphlet
@@ -91,6 +91,7 @@ integrate(x*exp(x),x)
 --R                                          Type: Union(Expression Integer,...)
 --E 2
 @
+
 \section{integrate $e^x cos(x) dx$}
 This integral will require the substituion by parts rule to be applied twice.
 
@@ -165,8 +166,8 @@ integrate(x^3*exp(x^2),x)
 --R              2
 --R                                          Type: Union(Expression Integer,...)
 --E 4
-@
 
+@
 \section{integrate $ln(x^2+2)dx$}
 To integrate
 $$\int{ln(x^2+2)dx}$$
@@ -194,49 +195,123 @@ integrate(log(x^2+2),x)
 --E 5
 @
 
-\section{integrate $ln(x) dx$}
+\section{integrate $x\ sin(x) dx$}
 To integrate
-$$\int{ln(x) dx}$$
+$$\int{x\ sin(x)\ dx}$$
 Let
-$$u=ln(x)$$
-$$dv=dx$$
-$$du=\frac{1}{x}dx$$
-$$v=x$$
+$$u=x$$
+$$dv=sin(x)\ dx$$
+$$du = dx$$
+$$v = -cos(x)$$
 so
-$$\int{ln(x)\ dx}$$
-$$=x\ ln(x)=\int{1\ dx}$$
-$$=x\ ln(x) - x + C$$
-$$=x(ln(x)-1)+C$$
+$$\int{x\ sin(x)\ dx}$$
+$$= -x\ cos(x) - \int{-cos(x)\ dx}$$
+$$= -x\ cos(x)+sin(x)+C$$
 <<*>>=
 --S 6
-integrate(log(x),x)
+integrate(x*sin(x),x)
 --R
---R   (6)  x log(x) - x
+--R   (6)  sin(x) - x cos(x)
 --R                                          Type: Union(Expression Integer,...)
 --E 6
 @
 
-\section{integrate $x\ sin(x) dx$}
+\section{integrate $x\ cos(x) dx$}
 To integrate
-$$\int{x\ sin(x)\ dx}$$
+$$\int{x\ cos(x)\ dx}$$
 Let
 $$u=x$$
-$$dv=sin(x)\ dx$$
+$$dv=cos(x)\ dx$$
 $$du = dx$$
-$$v = -cos(x)$$
+$$v = sin(x)$$
 so
-$$\int{x\ sin(x)\ dx}$$
-$$= -x\ cos(x) - \int{-cos(x)\ dx}$$
-$$= -x\ cos(x)+sin(x)+C$$
+$$\int{x\ cos(x)\ dx}$$
+$$= x\ sin(x) - \int{sin(x)\ dx}$$
+$$= x\ sin(x)+cos(x)+C$$
 <<*>>=
 --S 7
-integrate(x*sin(x),x)
+integrate(x*cos(x),x)
+--R 
 --R
---R   (7)  sin(x) - x cos(x)
+--R   (7)  x sin(x) + cos(x)
 --R                                          Type: Union(Expression Integer,...)
 --E 7
 @
 
+\section{integrate $x^2\ sin(x) dx$}
+To integrate
+$$\int{x^2\ sin(x)\ dx}$$
+Let
+$$u=x^2$$
+$$dv=sin(x)\ dx$$
+$$du = 2x\ dx$$
+$$v = -cos(x)$$
+so
+$$\int{x^2\ sin(x)\ dx}$$
+$$= -x^2\ cos(x) - \int{-2x\ cos(x)\ dx}$$
+$$= -x^2\ cos(x)+2\int{x\ cos(x)\ dx}$$
+$$=-x^2\ cos(x)+2(x\ sin(x)+cos(x))+C$$
+<<*>>=
+--S 8
+integrate(x^2*cos(x),x)
+--R 
+--R
+--R          2
+--R   (8)  (x  - 2)sin(x) + 2x cos(x)
+--R                                          Type: Union(Expression Integer,...)
+--E 8
+@
+
+\section{integrate $sin(x)\ cos(x)\ dx$}
+To integrate
+$$\int{sin(x)\ cos(x)\ dx}$$
+Let
+$$u=sin(x)$$
+$$dv=cos(x)\ dx$$
+$$du=cos(x)\ dx$$
+$$v=sin(x)$$
+so
+$$\int{sin(x)cos(x)dx}
+=sin(x)sin(x) - \int{sin(x)cos(x)dx}$$
+but the integral appears on both sides of the equation so
+$$2\int{sin(x)cos(x)dx}=sin^2(x)$$
+so
+$$\int{sin(x)cos(x)dx}=\frac{1}{2}sin^2(x)+C$$
+<<*>>=
+--S 9
+integrate(sin(x)*cos(x),x)
+--R 
+--R
+--R                2
+--R          cos(x)
+--R   (9)  - -------
+--R             2
+--R                                          Type: Union(Expression Integer,...)
+--E 9
+@
+
+\section{integrate $ln(x) dx$}
+To integrate
+$$\int{ln(x) dx}$$
+Let
+$$u=ln(x)$$
+$$dv=dx$$
+$$du=\frac{1}{x}dx$$
+$$v=x$$
+so
+$$\int{ln(x)\ dx}$$
+$$=x\ ln(x)=\int{1\ dx}$$
+$$=x\ ln(x) - x + C$$
+$$=x(ln(x)-1)+C$$
+<<*>>=
+--S 10
+integrate(log(x),x)
+--R
+--R   (10)  x log(x) - x
+--R                                          Type: Union(Expression Integer,...)
+--E 10
+@
+
 \section{integrate $x^2\ ln(x)\ dx$}
 To integrate
 $$\int{x^2\ ln(x)\ dx}$$
@@ -251,15 +326,38 @@ $$\frac{x^3}{3} ln(x) - \int{\frac{x^3}{3}\frac{dx}{x}}$$
 $$\frac{x^3}{3} ln(x)-\frac{1}{3}\int{x^2\ dx}$$
 $$\frac{x^3}{3}ln(x)-\frac{1}{9}x^3 + C$$
 <<*>>=
---S 8
+--S 11
 integrate(x^2*log(x),x)
 --R
---R          3          3
---R        3x log(x) - x
---R   (8)  --------------
---R               9
+--R           3          3
+--R         3x log(x) - x
+--R   (11)  --------------
+--R                9
 --R                                          Type: Union(Expression Integer,...)
---E 8
+--E 11
+@
+
+\section{integrate $x^2\ e^x\ dx$}
+To integrate
+$$\int{x^2\ e^x\ dx}$$
+Let
+$$u=x^2$$
+$$dv=e^x\ dx$$
+$$du = 2x\ dx$$
+$$v = e^x$$
+so
+$$\int{x^2\ e^x\ dx}$$
+$$x^2\ e^x - 2x\ e^x - \int{e^x\ 2dx}$$
+$$x^2\ e^x - 2x\ e^x+2\ e^x+C$$
+<<*>>=
+--S 12
+integrate(x^2*exp(x),x)
+--R 
+--R
+--R           2            x
+--R   (12)  (x  - 2x + 2)%e
+--R                                          Type: Union(Expression Integer,...)
+--E 12
 @
 
 \section{integrate $sin^{-1}(x)\ dx$}
@@ -278,15 +376,128 @@ $$=x\ sin^{-1}(x) + \frac{1}{2}(2(1-x^2)^{1/2})+C$$
 $$=x\ sin^{-1}(x)+(1-x^2)^{1/2}+C$$
 $$=x\ sin^{-1}(x)+\sqrt{1-x^2}+C$$
 <<*>>=
---S 9
-integrate(1/sin(x),x)
+--S 13
+integrate(asin(x),x)
+--R 
 --R
---R              sin(x)
---R   (9)  log(----------)
---R            cos(x) + 1
+--R                     +--------+
+--R                     |   2           +--------+
+--R                  2x\|- x  + 1       |   2
+--R         - x atan(-------------) + 2\|- x  + 1
+--R                       2
+--R                     2x  - 1
+--R   (13)  --------------------------------------
+--R                            2
 --R                                          Type: Union(Expression Integer,...)
---E 9
-)spool 
+--E 13
+@
+
+\section{integrate $\tan^{-1}(x)\ dx$}
+$$\int{\tan^{-1}(x)\ dx}$$
+Let
+$$u=tan^{-1}$$
+$$dv=dx$$
+$$du=\frac{1}{1+x^2}\ dx$$
+$$v=x$$
+so
+$$\int{\tan^{-1}(x)\ dx}$$
+$$=x\ \tan^{-1}-\int{\frac{x}{1+x^2}\ dx}$$
+$$=x\ tan^{-1}(x)-\frac{1}{2}\int{\frac{2x}{1+x^2}\ dx}$$
+$$=x\ tan^{-1}(x)-\frac{1}{2}ln(1+x^2)+C$$
+<<*>>=
+--S 14
+integrate(atan(x),x)
+--R 
+--R
+--R                2                 2x
+--R         - log(x  + 1) - x atan(------)
+--R                                 2
+--R                                x  - 1
+--R   (14)  ------------------------------
+--R                        2
+--R                                          Type: Union(Expression Integer,...)
+--E 14
+@
+
+\section{integrate $\sec^3(x)\ dx$}
+$$\int{\sec^3(x)\ dx}$$
+Let
+$$u=sec(x)$$
+$$dv=sec^2(x)\ dx$$
+$$du=sec(x)tan(x)\ dx$$
+$$v=tan(x)$$
+so
+$$\int{\sec^3(x)\ dx}$$
+$$=sec(x)tan(x)-\int{sec(x)tan^2(x)\ dx}$$
+$$=sec(x)tan(x)-\int{sec(x)(sec^2(x)-1)\ dx}$$
+$$=sec(x)tan(x)-\int{sec^3(x)\ dx}+\int{sec(x)\ dx}$$
+$$=sec(x)tan(x)-\int{sec^3(x)\ dx}+ln(\vert sec(x)+\tan(x)\vert )$$
+but
+$$=2\int{sec^3(x)\ dx}=sec(x)tan(x)+ln(\vert sec(x)+\tan(x)\vert )$$
+so
+$$\int{sec^3(x)\ dx}=
+\frac{1}{2}(sec(x)tan(x)+ln(\vert sec(x)+\tan(x)\vert ))+C$$
+<<*>>=
+--S 15
+integrate(sec(x)^3,x)
+--R 
+--R
+--R   (15)
+--R         2    sin(x) + cos(x) + 1          2    sin(x) - cos(x) - 1
+--R   cos(x) log(-------------------) - cos(x) log(-------------------) + sin(x)
+--R                   cos(x) + 1                        cos(x) + 1
+--R   --------------------------------------------------------------------------
+--R                                           2
+--R                                    2cos(x)
+--R                                          Type: Union(Expression Integer,...)
+--E 15
+@
+
+\section{integrate $x^3\ e^{2x}$}
+$$\int{x^3\ e^{2x}\ dx}$$
+Let
+$$u=x^3$$
+$$dv=e^{2x}\ dx$$
+$$du=3x^2\ dx$$
+$$v=\frac{1}{2}e^{2x}$$
+$$\int{x^3\ e^{2x}\ dx}$$
+$$=\frac{1}{2}x^3\ e^{2x} - \frac{3}{2}\int{x^2\ e^{2x}\ dx}$$
+
+To solve
+$$\frac{3}{2}\int{x^2\ e^{2x}\ dx}$$
+Let
+$$u=x^2$$
+$$dv=e^{2x}\ dx$$
+$$du=2x\ dx$$
+$$v=\frac{1}{2}e^{2x}$$
+so after substitution the new result is
+$$=\frac{1}{2}x^3\ e^{2x} - 
+\frac{3}{2}\left(\frac{1}{2}x^2\ e^{2x}-\int{xe^{2x}\ dx}\right)$$
+$$=\frac{1}{2}x^3\ e^{2x} - \frac{3}{4}x^2e^{2x}+
+\frac{3}{2}\int{xe^{2x}\ dx}$$
+Let
+$$u=x$$
+$$dv=e^{2x}\ dx$$
+$$du=dx$$
+$$v=\frac{1}{2}e^{2x}$$
+so
+$$\int{x^3\ e^{2x}\ dx}$$
+$$=\frac{1}{2}x^3\ e^{2x}-\frac{3}{4}x^2\ e^{2x}+
+\frac{3}{2}\left(\frac{1}{2}xe^{2x}-\frac{1}{2}\int{e^{2x}\ dx}\right)$$
+$$=\frac{1}{2}x^3\ e^{2x}-\frac{3}{4}x^2\ e^{2x}+
+\frac{3}{4}xe^{2x}-\frac{3}{8}e^{2x}+C$$
+<<*>>=
+--S 16
+integrate(x^3*exp(2*x),x)
+--R 
+--R
+--R            3     2            2x
+--R         (4x  - 6x  + 6x - 3)%e
+--R   (16)  ------------------------
+--R                     8
+--R                                          Type: Union(Expression Integer,...)
+--E 16
+)spool
 )lisp (bye)
 @
 
diff --git a/src/input/limit.input.pamphlet b/src/input/limit.input.pamphlet
index c210c87..ec80f68 100644
--- a/src/input/limit.input.pamphlet
+++ b/src/input/limit.input.pamphlet
@@ -5,24 +5,276 @@
 \author{Timothy Daly}
 \maketitle
 \begin{abstract}
+Exercise the limit function.
 \end{abstract}
 \eject
 \tableofcontents
 \eject
-\section{License}
-<<license>>=
---Copyright The Numerical Algorithms Group Limited 1991.
-@
+\section{Limit of a Function}
+If $f$ is a function, then 
+$$\lim_{x -> a}{f(x) = A}$$
+if the value of $f(x)$ gets arbitrarily close to $A$ as $x$ gets 
+arbitrarily close to $a$. For example, 
+$$\lim_{x->3}{x^2}=9$$
+since $x^2$ gets arbitrarily close to 9 as $x$ approaches 3.
+
+By definition, the limit 
+$$\lim_{x -> a}{f(x) = A}$$ if and only if, for any chosen positive
+number $\epsilon$, however small, there exists a positive number 
+$\delta$ such that
+$$0 < \vert x-a \vert < \delta {\tt\ implies\ }
+\vert f(x)-A \vert < \epsilon$$
+Note that $f(x)$ does not need to be defined at $a$.
+
 <<*>>=
 )spool limit.output
 )set message test on
 )set message auto off
 )clear all
  
+--S 1 of 15
+limit((x^2-4)/(x-2),x=2)
+--R 
+--R
+--R   (1)  4
+--R               Type: Union(OrderedCompletion Fraction Polynomial Integer,...)
+--E 1
+@
+\section{Right and Left Limits}
+The limit
+$$\lim_{x -> a^-}{f(x) = A}$$
+given that $f$ is defined in the interval $(c,a)$ and $f(x)$
+approaches $A$ as $x$ approaches $a$ through the values less than
+$a$, that is, as $x$ approaches $a$ from the left. 
+
+Similarly
+$$\lim_{x -> a^+}{f(x) = A}$$
+means that $f$ is defined in some interval $(a,d)$ and $f(x)$
+approaches $A$ as $x$ approaches $a$ from the right. 
+
+If $f$ is defined in an interval to the left of $a$ and in an interval
+to the right of $a$ then the statement
+$$\lim_{x -> a}{f(x) = A}$$
+is equivalent to the conjunction of the two statements
+$$\lim_{x -> a^-}{f(x) = A} {\rm\ and\ } \lim_{x -> a^+}{f(x) = A}$$.
+
+The existence of the limit from the left does not imply the existence
+of the limit from the right.  The existence of the limit from the
+right does not imply the existence of the limit from the left.
+
+When a function is defined only on one side of a point $a$, then
+$$\lim_{x -> a}{f(x)}$$
+is identical with the one-sided limit, if it exists. A two-sided
+limit might not exist because it is not defined outside a certain 
+bound. For example, if
+$$f(x)=\sqrt{x}$$
+then $f$ is defined only at and to the right of 0. Hence,
+$$\lim_{x->0}{\sqrt{x}}=\lim_{x->0^+}{\sqrt{x}}=0$$
+But the limit
+$$\lim_{x->0^-}{\sqrt{x}}$$
+does not exist since $\sqrt{x}$ is not defined for real values of $x$.
+
+A limit might not exist because the function grows without bound
+as it approaches the limit point. For example, the function
+$\sqrt{\frac{1}{x}}$ is only defined when $x > 0$. So
+$$\lim_{x->0^+}{\sqrt{\frac{1}{x}}}$$
+does not exist since $\frac{1}{x}$ gets larger as $x -> 0$ from
+the right. So
+$$\lim_{x->0}{\sqrt{\frac{1}{x}}}$$
+does not exist.
+
+<<*>>=
+--S 2 of 15
+limit(sqrt(9-x^2),x=-4)
+--R 
+--R
+--R   (2)  "failed"
+--R                                                    Type: Union("failed",...)
+--E 2
+
+--S 3 of 15
+limit(sqrt(9-x^2),x=-3)
+--R 
+--R
+--R   (3)  [leftHandLimit= "failed",rightHandLimit= 0]
+--RType: Union(Record(leftHandLimit: Union(OrderedCompletion Expression Integer,"failed"),rightHandLimit: Union(OrderedCompletion Expression Integer,"failed")),...)
+--E 3
+
+--S 4 of 15
+limit(sqrt(9-x^2),x=-2)
+--R 
+--R
+--R         +-+
+--R   (4)  \|5
+--R                        Type: Union(OrderedCompletion Expression Integer,...)
+--E 4
+
+--S 5 of 15
+limit(sqrt(9-x^2),x=0)
+--R 
+--R
+--R   (5)  3
+--R                        Type: Union(OrderedCompletion Expression Integer,...)
+--E 5
+
+--S 6 of 15
+limit(sqrt(9-x^2),x=2)
+--R 
+--R
+--R         +-+
+--R   (6)  \|5
+--R                        Type: Union(OrderedCompletion Expression Integer,...)
+--E 6
+
+--S 7 of 15
+limit(sqrt(9-x^2),x=3)
+--R 
+--R
+--R   (7)  [leftHandLimit= 0,rightHandLimit= "failed"]
+--RType: Union(Record(leftHandLimit: Union(OrderedCompletion Expression Integer,"failed"),rightHandLimit: Union(OrderedCompletion Expression Integer,"failed")),...)
+--E 7
+
+--S 8 of 15
+limit(sqrt(9-x^2),x=4)
+--R 
+--R
+--R   (8)  "failed"
+--R                                                    Type: Union("failed",...)
+--E 8
+
 @
+\section{Theorems on Limits}
+If $$f(x)=c$$ where $c$ is a constant, then
+$$\lim_{x->a}{f(x)=c}$$
+
+Assume that 
+$$\lim_{x->a}{f(x)=A}{\rm\ and\ }\lim_{x->a}{g(x)=B}$$
+then the limit of a constant times a function is 
+the constant times limit of a function is
+the constant times the limit.
+$$\lim_{x->a}{cf(x)}=
+c*\lim_{x->a}{f(x)=
+cA}$$
+
+The limit of a function plus (or minus) another function is
+the limit of the first function plus (or minus)
+the limit of the second function is
+the sum (or difference) of their limits.
+$$\lim_{x->a}{[f(x)\pm{}g(x)]}=
+\lim_{x->a}{f(x)}\pm\lim_{x->a}{g(x)}=
+A\pm{}B$$
+
+The limit of the product of functions is
+the limit of the first function times the limit of the second function is
+the product of their limits.
+$$\lim_{x->a}{[f(x)g(x)]}=
+\lim_{x->a}{f(x)}*\lim_{x->a}{g(x)}=
+A*B$$
+
+The limit of the ratio of two functions is 
+the the limit of the first function divided by the limit of the
+second function provided the limit of the second function is non-zero.
+$$\lim_{x->a}{\left(\frac{f(x)}{g(x)}\right)}=
+\frac{\lim_{x->a}{f(x)}}{\lim_{x->a}{g(x)}}=
+\frac{A}{B},
+{\rm\ if\ }B\ne{}0$$
+
+The limit of the ${\rm{}n}^{th}$ root of a function is
+the ${\rm{}n}^{th}$ root of the limit of the function provided
+the ${\rm{}n}^{th}$ root exists.
+$$\lim_{x->a}{\sqrt[n]{f(x)}}=\sqrt[n]{\lim_{x->a}{f(x)}}=
+\sqrt[n]{A},{\rm\ if\ }\sqrt[n]{A}{\rm\ is\ defined}$$
+
 The returned limit seems to be wrong:
+
+\section{Infinity}
+Let
+$$\lim_{x->a}{f(x)}=+\infty$$
+mean that, as $x$ approaches $a$, $f(x)$ eventually becomes and
+therefore remains greater than any preassigned positive number,
+however large. In such a case, we say that $f(x)$ approaches
+$+\infty$ as $x$ approaches $a$. The
+$$\lim_{x->a}{f(x)}=+\infty$$
+if and only if, for any positive number $M$, there exists a
+positive number $\delta$ such that, whenever
+$$0 < \vert x-a \vert < \delta {\rm\ then\ }f(x) > M$$
+
+Similarly, let
+$$\lim_{x->a}{f(x)}=-\infty$$
+mean that, as $x$ approaches $a$, $f(x)$ eventually becomes and 
+thereafter remains less than any preassigned negative number. In
+that case, we say that $f(x)$ approaches
+$-\infty$ as $x$ approaches $a$. 
+
+Let
+$$\lim_{x->a}{f(x)}=\infty$$
+mean that, as $x$ approaches $a$, $\vert f(x)\vert$ eventually becomes and 
+thereafter remains greater than any preassigned positive number. Hence,
+$$\lim_{x->a}{f(x)}=\infty$$ if and only if 
+$$\lim_{x->a}{\vert f(x)\vert}=+\infty$$
+
+These definitions can be extended to one-sided limits.
+
+<<*>>=
+--S 9 of 15
+limit(1/x^2,x=0)
+--R 
+--R
+--R   (9)   + infinity
+--R               Type: Union(OrderedCompletion Fraction Polynomial Integer,...)
+--E 9
+
+--S 10 of 15
+limit(-1/(x-1)^2,x=1)
+--R 
+--R
+--R   (10)  - infinity
+--R               Type: Union(OrderedCompletion Fraction Polynomial Integer,...)
+--E 10
+
+--S 11 of 15
+limit(1/x,x=0)
+--R 
+--R
+--R   (11)  [leftHandLimit= - infinity,rightHandLimit=  + infinity]
+--RType: Union(Record(leftHandLimit: Union(OrderedCompletion Fraction Polynomial Integer,"failed"),rightHandLimit: Union(OrderedCompletion Fraction Polynomial Integer,"failed")),...)
+--E 11
+
+@
+The limit concepts already introduced can be extended to the case
+where the variable approaches $+\infty$ or $-\infty$. For example,
+$$\lim_{x->+\infty}{f(x)}=A$$
+means that $f(x)$ approaches $A$ as $x -> +\infty$ or, in more 
+precise terms, given any positive $\epsilon$, there exists a
+number $N$ such that, whenever $x>N$, then 
+$$\vert f(x)-A\vert < \epsilon$$
+
+Similar statements can be made for:
+$$\lim_{x->-\infty}{f(x)}=A$$
+$$\lim_{x->+\infty}{f(x)}=+\infty$$
+$$\lim_{x->-\infty}{f(x)}=-\infty$$
+$$\lim_{x->+\infty}{f(x)}=-\infty$$
+$$\lim_{x->-\infty}{f(x)}=+\infty$$
 <<*>>=
---S 1 of 2
+--S 12 of 15
+limit(1/x,x=%plusInfinity)
+--R 
+--R
+--R   (12)  0
+--R               Type: Union(OrderedCompletion Fraction Polynomial Integer,...)
+--E 12
+
+--S 13 of 15
+limit(2+(1/x^2),x=%plusInfinity)
+--R 
+--R
+--R   (13)  2
+--R               Type: Union(OrderedCompletion Fraction Polynomial Integer,...)
+--E 13
+
+)clear all
+
+--S 14 of 15
 f := exp(n) * (sin(1/n + exp(-n)) - sin(1/n))
 --R 
 --R
@@ -31,22 +283,24 @@ f := exp(n) * (sin(1/n + exp(-n)) - sin(1/n))
 --R   (1)  %e sin(-----------) - %e sin(-)
 --R                    n                n
 --R                                                     Type: Expression Integer
---E 1
+--E 14
 
---S 2 of 2
+--S 15 of 15
 limit(f,n=%plusInfinity)
 --R 
 --R
 --R   (2)  "failed"
 --R                                                    Type: Union("failed",...)
---E 2
+--E 15
 )spool 
 )lisp (bye)
  
 @
 \eject
 \begin{thebibliography}{99}
-\bibitem{1} nothing
+\bibitem{1} Ayres, Frank Jr. and Mendelson, Elliott
+``Calculus'' Schaum's Outlines 4th edition 1999
+ISBN 0-07-041973-6 pp61-63
 \end{thebibliography}
 \end{document}
 
